<ul class="breadcrumb">
    <li>
        <a href="<?= $this->url('root') ?>"><?= $this->icon('home') ?></a>
    </li>
    <li><?= $this->translate('budget_module_title') ?></li>
    <li class="active"><?= $this->translate('destination_module_title') ?></li>
</ul>

<h1 class="page-title">
    <?= $this->icon('destination') ?>
    <?= $this->translate('destination_module_title') ?>
</h1>

<div class="row row-padding">
    <div class="col-xs-12">
        <div class="panel" ng-controller="destinationListController as self">
            <table-builder options="self.options" items="self.destinations" class="table-builder">
                <div class="panel-heading">
                    <?= $this->translate('destination_nav_list') ?>
                    <div class="panel-heading-right">
                        <div
                            class="panel-heading-actions"
                            tooltip="<?= $this->translate('tooltip_remove_from_list') ?>"
                        >
                            <?= $this->icon('eraser', 'fa-fw pointer', [
                                'ng-click' => '__tb.removeFromList()',
                            ]) ?>
                        </div>
                        <div
                            class="panel-heading-actions"
                            tooltip="<?= $this->translate('tooltip_export_xls') ?>"
                        >
                            <?= $this->icon('excel', 'fa-fw pointer', [
                                'ng-click' => '__tb.exportExcel()',
                            ]) ?>
                        </div>
                        <div
                            class="panel-heading-actions"
                            tooltip="<?= $this->translate('tooltip_refresh') ?>"
                        >
                            <?= $this->icon('refresh', 'fa-fw pointer', [
                                'ng-click' => '__tb.loadData()',
                            ]) ?>
                        </div>
                    </div>
                </div>
                <div class="panel-body">
                    <div class="row">
                        <div class="col-sm-4">
                            <div class="table-filters little-panel">
                                <div class="title table-filters-header">
                                    <div class="input-group">
                                        <div
                                            class="input-group-addon pointer"
                                            data-toggle="collapse"
                                            href="#filters-collapsed"
                                        >
                                            <?= $this->icon('filters', 'fa-fw') ?>
                                            <span class="caret"></span>
                                        </div>
                                        <input
                                            type="text"
                                            placeholder="<?= $this->translate('search', null, null, false) ?>"
                                            class="form-control"
                                            ng-model="self.fullText"
                                            id="full-text"
                                            on-enter="self.fullTextSearch()"
                                        />
                                        <div
                                            class="input-group-addon pointer"
                                            ng-click="self.fullTextSearch()"
                                        >
                                            <?= $this->icon('search', 'fa-fw') ?>
                                        </div>
                                    </div>
                                </div>
                                <div id="filters-collapsed" class="body collapse">
                                    <?php
                                    $filters = [
                                        'code' => [
                                            'label' => $this->translate('destination_field_code'),
                                            'type' => 'string',
                                        ],
                                        'name' => [
                                            'label' => $this->translate('destination_field_name'),
                                            'type' => 'string',
                                        ],
                                        'parent' => [
                                            'label' => $this->translate('destination_field_parent'),
                                            'type' => 'destination-select',
                                        ],
                                        'createdAt' => [
                                            'label' => $this->translate('destination_field_createdAt'),
                                            'type' => 'date',
                                        ],
                                        'updatedAt' => [
                                            'label' => $this->translate('destination_field_updatedAt'),
                                            'type' => 'date',
                                        ],
                                    ];

                                    foreach ($this->groups as $group) {
                                        $filters['keyword.' . $group->getId()] = [
                                            'label' => $group->getName(),
                                            'type' => 'keyword-select',
                                            'group' => $group->getId(),
                                        ];
                                    }

                                    echo $this->tableFilter('__tb.apiParams.search.data.filters', $filters);
                                    ?>
                                    <div class="row">
                                        <div class="col-xs-6">
                                            <button
                                                class="btn"
                                                ng-click="self.resetfullTextSearch(); __tb.resetFilters(); __tb.loadData()"
                                            >
                                                <?= $this->translate('table_filter_reset_button') ?>
                                            </button>
                                        </div>
                                        <div class="col-xs-6 text-right">
                                            <button
                                                class="btn"
                                                ng-click="self.resetfullTextSearch(); __tb.loadData()"
                                            >
                                                <?= $this->icon('search', 'fa-fw') ?>
                                                <?= $this->translate('table_filter_button') ?>
                                            </button>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="col-sm-4">
                            <table-builder-columns></table-builder-columns>
                        </div>
                        <?php if ($this->acl()->isAllowed('application:e:query:r')): ?>
                            <div class="col-sm-4">
                                <table-builder-queries></table-builder-queries>
                            </div>
                        <?php endif; ?>
                    </div>
                    <div class="row">
                        <div class="col-xs-12">
                            <form name="destinationForm">
                                <table
                                    table-builder-table
                                    class="table table-bordered table-condensed table-hover"
                                >
                                    <thead>
                                        <tr>
                                            <th
                                                tb-column
                                                tb-name="selection"
                                                class="checkbox-column"
                                            >
                                                <input type="checkbox" ng-model="__tb.selection" />
                                            </th>

                                            <th
                                                tb-column
                                                tb-name="code"
                                                tb-sortable="true"
                                                tb-toggle="true"
                                            >
                                                <?= $this->translate('destination_field_code') ?>
                                            </th>

                                            <th
                                                tb-column
                                                tb-name="name"
                                                tb-sortable="true"
                                                tb-toggle="true"
                                            >
                                                <?= $this->translate('destination_field_name') ?>
                                            </th>

                                            <th
                                                tb-column
                                                tb-name="parent"
                                                tb-sortable="true"
                                                tb-toggle="true"
                                            >
                                                <?= $this->translate('destination_field_parent') ?>
                                            </th>

                                            <th
                                                tb-column
                                                tb-name="createdAt"
                                                tb-sortable="true"
                                                tb-toggle="true"
                                                tb-hidden="true"
                                            >
                                                <?= $this->translate('destination_field_createdAt') ?>
                                            </th>

                                            <th
                                                tb-column
                                                tb-name="updatedAt"
                                                tb-sortable="true"
                                                tb-toggle="true"
                                                tb-hidden="true"
                                            >
                                                <?= $this->translate('destination_field_updatedAt') ?>
                                            </th>

                                            <th
                                                tb-column
                                                tb-name="actions"
                                                class="actions-column"
                                            ></th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        <tr
                                            ng-repeat="destination in self.destinations"
                                            ng-class="{editing: self.editedLine == destination}"
                                        >
                                            <td>
                                                <input type="checkbox" ng-model="destination.selected" />
                                            </td>
                                            
                                            <td class="editable">
                                                <span ng-show="self.editedLine !== destination">
                                                    <a
                                                        ng-if="destination._rights.read"
                                                        href="<?= $this->url('budget/destination/form') ?>/{{destination.id}}"
                                                    >
                                                        {{destination.code}}
                                                    </a>

                                                    <span ng-if="!destination._rights.read">
                                                        {{destination.code}}
                                                    </span>

                                                    <?= $this->icon('inline-edit', '', [
                                                        'ng-click' => 'self.editLine(destination)',
                                                        'ng-if' => 'destination._rights.update',
                                                    ]) ?>
                                                </span>

                                                <span ng-if="self.editedLine == destination">
                                                    <input
                                                        type="text"
                                                        class="form-control input-sm"
                                                        ng-model="self.editedLineFields.code"
                                                    />

                                                    <field-errors
                                                        field="code"
                                                        errors="self.editedLineErrors"
                                                    ></field-errors>
                                                </span>
                                            </td>
                                            
                                            <td class="editable">
                                                <span ng-show="self.editedLine !== destination">
                                                    <a
                                                        ng-if="destination._rights.read"
                                                        href="<?= $this->url('budget/destination/form') ?>/{{destination.id}}">
                                                        {{destination.name}}
                                                    </a>

                                                    <span ng-if="!destination._rights.read">
                                                        {{destination.name}}
                                                    </span>

                                                    <?= $this->icon('inline-edit', '', [
                                                        'ng-click' => 'self.editLine(destination)',
                                                        'ng-if' => 'destination._rights.update',
                                                    ]) ?>
                                                </span>
                                                <span ng-if="self.editedLine == destination">
                                                    <input
                                                        type="text"
                                                        class="form-control input-sm"
                                                        ng-model="self.editedLineFields.name"
                                                        required
                                                    />
                                                    <field-errors
                                                        field="name"
                                                        errors="self.editedLineErrors"
                                                    ></field-errors>
                                                </span>
                                            </td>

                                            <td class="editable">
                                                <span ng-show="self.editedLine !== destination">
                                                    <a
                                                        ng-if="destination.parent._rights.read"
                                                        href="<?= $this->url('budget/destination/form') ?>/{{destination.parent.id}}">
                                                        {{destination.parent.name}}
                                                    </a>

                                                    <span ng-if="!destination.parent._rights.read">
                                                        {{destination.parent.name}}
                                                    </span>

                                                    <?= $this->icon('inline-edit', '', [
                                                        'ng-click' => 'self.editLine(destination)',
                                                        'ng-if' => 'destination._rights.update',
                                                    ]) ?>
                                                </span>
                                                <span ng-if="self.editedLine == destination">
                                                    <destination-select
                                                        ng-model="self.editedLineFields.parent"
                                                        configuration="{
                                                            service: {
                                                                apiParams: {
                                                                    search: {
                                                                        data: {
                                                                            filters: {
                                                                                id: {
                                                                                    op: 'neq',
                                                                                    val: self.editedLineFields.id
                                                                                }
                                                                            }
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }"
                                                    ></destination-select>
                                                    <field-errors
                                                        field="parent"
                                                        errors="self.editedLineErrors"
                                                    ></field-errors>
                                                </span>
                                            </td>

                                            <td>
                                                {{destination.createdAt | dateFormat : 'DD/MM/YYYY'}}
                                            </td>

                                            <td>
                                                {{destination.updatedAt | dateFormat : 'DD/MM/YYYY'}}
                                            </td>

                                            <td>
                                                <div
                                                    class="btn-group btn-group-actions"
                                                    ng-if="self.editedLine !== destination"
                                                >
                                                    <?php if ($this->acl()->isAllowed('budget:e:destination:r')): ?>
                                                        <a
                                                            ng-if="destination._rights.read"
                                                            href="<?= $this->url('budget/destination/form') ?>/{{destination.id}}"
                                                            class="btn btn-xs btn-default"
                                                            tooltip="<?= $this->translate('tooltip_edit') ?>"
                                                        >
                                                            <?= $this->icon('edit') ?>
                                                        </a>
                                                    <?php endif; ?>

                                                    <?php if ($this->acl()->isAllowed('budget:e:destination:d')): ?>
                                                        <a
                                                            ng-if="destination._rights.delete"
                                                            href=""
                                                            class="btn btn-xs btn-default"
                                                            tooltip="<?= $this->translate('tooltip_delete') ?>"
                                                            ng-click="self.deleteDestination(destination)"
                                                        >
                                                            <?= $this->icon('delete') ?>
                                                        </a>
                                                    <?php endif; ?>
                                                </div>
                                                <div
                                                    class="btn-group btn-group-actions"
                                                    ng-if="self.editedLine == destination"
                                                >
                                                    <button
                                                        class="btn btn-xs btn-default"
                                                        ng-click="self.saveEditedLine(destination)"
                                                        type="submit"
                                                        tooltip="<?= $this->translate('tooltip_save') ?>"
                                                    >
                                                        <?= $this->icon('save') ?>
                                                    </button>
                                                    <button
                                                        class="btn btn-xs btn-default"
                                                        ng-click="self.editedLine = null"
                                                        type="button"
                                                        tooltip="<?= $this->translate('tooltip_cancel') ?>"
                                                    >
                                                        <?= $this->icon('close') ?>
                                                    </button>
                                                </div>
                                            </td>
                                        </tr>
                                    </tbody>
                                </table>
                            </form>
                        </div>
                    </div>
                </div>
            </table-builder>
        </div>
    </div>
</div>

<?php
$fabLinks = [];

if ($this->acl()->isAllowed('budget:e:destination:c')) {
    $fabLinks[] = [
        'href' => $this->url('budget/destination/form'),
        'text' => $this->icon('create', 'fa-fw') . ' ' . $this->translate('destination_nav_form'),
    ];
    $fabLinks[] = [
        'href' => $this->url('import', ['entity' => 'destination']),
        'text' => $this->icon('import', 'fa-fw') . ' ' . $this->translate('destination_nav_import'),
    ];
}
echo $this->fabMenu($fabLinks);
?>

<?php
$this->angular('js/src/budget/controller/destination/list.js');
$this->angular('js/src/budget/service/destination.js');
$this->angular('js/src/budget/directive/destinationSelect.js');

$this->angular('js/src/application/query/service/query.js');

